#include <stdio.h>
#include <conio.h>
#include <windows.h>

#define MAX 50
#define DAME -1
#define FREI 0

int dame(int anzahl, int feld[MAX][MAX], int dimX, int dimY);

void dameSetzen(int feld[MAX][MAX], int dimX, int dimY, int posX, int posY);

void dameLoeschen(int feld[MAX][MAX], int dimX, int dimY, int posX, int posY);

void init(int feld[MAX][MAX], int dimX, int dimY);

void ausgabe(int feld[MAX][MAX], int dimX, int dimY);

void setcolor(unsigned short color);


main()
{
    int dimX, dimY;
    int anzahl=1;
    int feld[MAX][MAX];
    
    printf("\t\t\tDamenproblem\n\n");
    
    printf("\tBitte Dimensionen eingeben! (Zeile, Spalte)\n");
    scanf("%d %d", &dimY, &dimX);
    init(feld, dimX, dimY);
    
    printf("\tBitte Anzahl der Damen eingeben:\n");
    scanf("%d", &anzahl);
    
    if( dame(anzahl, feld, dimX, dimY) )
        ausgabe(feld, dimX, dimY);
    else
        printf("nicht moeglich die Damen unter zu bringen\n");
    
    getch();
}


int dame(int anzahl, int feld[MAX][MAX], int dimX, int dimY)
{
    int posX=0, posY=0;
    
    if(anzahl > 0)
    {
        while( posY < dimY )
        {
            while( posX < dimX )
            {
                if(feld[posY][posX] == 0)
                {
                    //freies feld
                    dameSetzen(feld, dimX, dimY, posX, posY);
                    if( dame(anzahl-1, feld, dimX, dimY) )
                        return 1;
                    else
                        dameLoeschen(feld, dimX, dimY, posX, posY);
                }
                posX++;
            }
            posX=0;
            posY++;
        }
        return 0;
    }
    else
        return 1;
    
    return 0;
}




void dameSetzen(int feld[MAX][MAX], int dimX, int dimY, int posX, int posY)
{
    int x, y;
    
    for(y = 0; y < dimY; y++)   //von oben nach unten
        ++feld[y][posX];
    
    
    for(x = 0; x < dimX; x++)   //von links nach rechts
        ++feld[posY][x];
    
    
    x = posX;
    y = posY;
    while(y >= 0 && x < dimX)     //nach oben rechts
        ++feld[y--][x++];
     
    
    x = posX;
    y = posY;
    while(y >= 0 && x >= 0)     //nach oben links
        ++feld[y--][x--];
    
    
    x = posX;
    y = posY;
    while(y < dimY && x >= 0)     //nach unten links
        ++feld[y++][x--];
    
    
    x = posX;
    y = posY;
    while(y < dimY && x < dimX)     //nach unten rechts
        ++feld[y++][x++];
    
    
    feld[posY][posX] = DAME;
    
    return;
}



void dameLoeschen(int feld[MAX][MAX], int dimX, int dimY, int posX, int posY)
{
    int x, y;
    
    for(y = 0; y < dimY; y++)   //von oben nach unten
        --feld[y][posX];
    
    
    for(x = 0; x < dimX; x++)   //von links nach rechts
        --feld[posY][x];
    
    
    x = posX;
    y = posY;
    while(y >= 0 && x < dimX)     //nach oben rechts
        --feld[y--][x++];
     
    
    x = posX;
    y = posY;
    while(y >= 0 && x >= 0)     //nach oben links
        --feld[y--][x--];
    
    
    x = posX;
    y = posY;
    while(y < dimY && x >= 0)     //nach unten links
        --feld[y++][x--];
    
    
    x = posX;
    y = posY;
    while(y < dimY && x < dimX)     //nach unten rechts
        --feld[y++][x++];
    
    
    feld[posY][posX] = FREI;
    
    return;
}



void init(int feld[MAX][MAX], int dimX, int dimY)
{
    for( ; dimY>=0; dimY--)
        for( ; dimX>=0; dimX--)
            feld[dimY][dimX] = FREI;
    return;
}



void ausgabe(int feld[MAX][MAX], int dimX, int dimY)
{
    int zeile, spalte;
    
    printf("\t\t");setcolor(136);printf("+");    //oberer Rahmen
    for(spalte=0; spalte<dimX; spalte++)
        printf("--");
    printf("+");setcolor(7);printf("\n");
    
    for(zeile=0; zeile<dimY; zeile++)
    {
        printf("\t\t");setcolor(136);printf("|");setcolor(7);    //linker Rahmen
        for(spalte=0; spalte<dimX; spalte++)
        {
            if(feld[zeile][spalte] == DAME)
            {
                setcolor(12);printf(" D");setcolor(7);
            }
            if(feld[zeile][spalte] == FREI)
            {
                setcolor(7);printf(" %d", feld[zeile][spalte]);setcolor(7);
            }
            if(feld[zeile][spalte] > 0)
            {
                setcolor(7);printf(" %d", feld[zeile][spalte]);setcolor(7);
            }
        }
        setcolor(136);printf("|");setcolor(7);printf("\n");    //rechter Rahmen
    }
    
    printf("\t\t");setcolor(136);printf("+");   //unterer Rahmen
    for(spalte=0; spalte<dimX; spalte++)
        printf("--");
    printf("+");setcolor(7);printf("\n\n");
    
    return;
}


void setcolor(unsigned short color)
{
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleTextAttribute(hcon,color);
}

