/**************************
 *      FH-DATENBANK      *
 *          von           *
 *  Andreas Zimmerschitt  *
 *************************/
 
/*      INCLUDES        */
#include <stdio.h>
#include <conio.h>
#include <string.h>


/*      DEFINES         */
#define NICHTANGEMELDET -1
#define ETECH       0
#define PROG       1
#define IGRU        2
#define ANLI        3



/*      DATENSTRUKTUREN     */
typedef struct{
    char matrikelnummer[21];
    char vorname[21];
    char nachname[21];
    char email[21];
    char telefon[21];
    int anz;
    int klausur[4];
}t_daten;

typedef struct listElem{
    t_daten *daten;
    struct listElem *prev;
    struct listElem *next;
}t_listElem;

typedef struct{
    t_listElem *anfang;
    t_listElem *aktuell;
    t_listElem *ende;
}t_liste;





/*      PROTOTYPEN      */
int createList(t_liste **liste);
int einfuegen(t_daten *neuedaten, t_liste *liste);
int loeschen(char *mnummer, t_liste *liste);
int einlogen(char *mnummer, t_liste *liste);
int eingeben(t_liste *liste);
int vorhanden(char *mnummer, t_liste *liste);
void auslogen(t_liste *liste);
void printListe(t_liste *liste);
void laden(t_liste *liste);
void speichern(t_liste *liste);

void printKlausurAnmeldungen(t_daten *daten);
void klausurAnmeldung(int fach, t_daten *daten);
void klausurAbmeldung(int fach, t_daten *daten);




/*      MAIN        */
main()
{
    char auswahl, nummer[10];
    int done = 1, anmeldung = 0, login = 0, i=0, fach;
    t_liste *meineliste;
    
    
    if(!createList(&meineliste))
        return;
     
    
    
    //mainloop
    while(done)
    {
        printf("\n\t\t\tAdministor Ebene\n");
        printf("\t B  Benutzer Ebene\n");
        printf("\t L  Datenbank Laden\n");
        printf("\t S  Datenbank Speichern\n");
        printf("\t N  Neuen Datensatz anlegen\n");
        printf("\t D  Datensatz Loeschen\n");
        printf("\t P  Datenbank Ausgeben\n");
        printf("\t 0  Programm verlassen\n\n");
        
        auswahl = getch();
        
        if(auswahl == 'l')
            laden(meineliste);
        if(auswahl == 's')
            speichern(meineliste);
        if(auswahl == 'p')
            printListe(meineliste);
        if(auswahl == 'd')
        {
            printf("\tBitte Matrikelnummer des zu loeschenden Datensatzes eingeben: \n");
            scanf("%s", nummer);
            loeschen(nummer, meineliste);
        }
        if(auswahl == '0')
            done = 0;
        if(auswahl == 'n')
        {
            i=0;
            do{ i++;
            }while( (i < 3) && (eingeben(meineliste)==0) );
        }
        if(auswahl == 'b')
        {
            anmeldung = 1;
            while(anmeldung)
            {
                printf("\n\t\t\tBenutzer Ebene\n");
                
                printf("\t N  Neuen Benutzer anlegen\n");
                printf("\t L  Benutzer einlogen\n");
                printf("\t P  Benutzerliste Ausgeben\n");
                printf("\t 0  zurueck\n\n");
                
                auswahl = getch();
                
                if(auswahl == 'n')
                {
                    i=0;
                    do{ i++;
                    }while( (i < 3) && (eingeben(meineliste)==0) );
                }
                if(auswahl == 'p')
                    printListe(meineliste);
                if(auswahl == '0')
                    anmeldung = 0;
                if(auswahl == 'l')
                {
                    login = 1;
                    printf("\tBitte Matrikelnummer eingeben: \n");
                    scanf("%s", nummer);
                    if(einlogen(nummer, meineliste))
                    {
                        printf("\t Willkommen %s %s!\n\n",  meineliste->aktuell->daten->vorname,
                                                            meineliste->aktuell->daten->nachname );
                        while(login)
                        {
                            printf("\t\tWelche Aktion moechtest du ausfuehren?\n");
                            
                            printf("\t N  KlausuraNmeldung\n");
                            printf("\t B  KlausuraBmeldung\n");
                            printf("\t A  Angemeldete KLausuren\n");
                            printf("\t 0  Auslogen\n\n");
                            
                            auswahl = getch();
                            if(auswahl == '0')
                            {
                                auslogen(meineliste);
                                login = 0;
                            }
                            if(auswahl == 'a')
                            {
                                printKlausurAnmeldungen(meineliste->aktuell->daten);
                            }
                            if(auswahl == 'n')
                            {
                                printf("\t 0  Programmieren1\n");
                                printf("\t 1  Programmieren2\n");
                                printf("\t 2  Informatik Grundlagen\n");
                                printf("\t 3  Analysis und Lineare Algebra\n\n");
                                printf("Bitte Nummer der Klausur eingeben:\n");
                                
                                scanf("%d", &fach);
                                klausurAnmeldung(fach, meineliste->aktuell->daten);//anmeldung
                            }
                            if(auswahl == 'b')
                                klausurAbmeldung(2, meineliste->aktuell->daten);//abmeldung
                        }//while(login)
                    }
                    else
                        printf("\tLogin fehlgeschlagen!\n");
                }
            }//while(anmeldung)
        }
    }//while(done)
}



/*******************************

            EINFGEN             
    
********************************/

int einfuegen(t_daten *neuedaten, t_liste *liste)
{
    t_listElem *neu;
    neu = (t_listElem*) malloc(sizeof(t_listElem));
    
    
    neu->daten = neuedaten;
    neu->daten->anz = 0;
    neu->next = NULL;
    neu->prev = NULL;
            
    
    if(liste->anfang == NULL && liste->ende == NULL)
    {
        //noch nichts in der Liste vorhanden
        liste->anfang = neu;
        liste->ende = neu;
        return 0;
    }
    else
    {
        neu->next = liste->anfang;
        liste->anfang->prev = neu;
        liste->anfang = neu;
        
    }
}


/*******************************

            EINGEBEN             
    
********************************/


int eingeben(t_liste *liste)
{
    t_daten *temp;
    temp = (t_daten*) malloc(sizeof(t_daten));
            
    printf("\n\nBitte Matrikelnummer, Nachname, Vorname, email, telefon  eingeben\n\n");
    scanf("%s %s %s %s %s", temp->matrikelnummer, temp->nachname,
                            temp->vorname, temp->email, temp->telefon );
                                    
    if(vorhanden(temp->matrikelnummer, liste))
    {
        printf("\t\tKein Erfolg!\n");
        return 0;
    }
    einfuegen(temp, liste);
    free(*temp);
    return 1;
}





/*******************************

            LSCHEN             
    
********************************/


int loeschen(char *remove, t_liste *liste)
{
    t_listElem *temp;
    t_listElem *deleteme;
    
    int i=0;
    temp = liste->anfang;
    
    //sonderfall Datenbank leer
    if(temp == NULL)
    {
        printf("\t\t\tDatenbank ist leer! Loeschen nicht moeglich!\n");
        return 0;
    }
    
    
    //suchen bis Matrikelnummer gefunden
    while( strcmp( temp->daten->matrikelnummer, remove ) != 0 )
    {
        //listenende erreicht?
        if (temp == liste->ende)
        {
            printf("\t\t\tMatrikelnummer nicht gefunden!\n");
            return 0;
        }
        //sonst ein listenelement weiter
        temp = temp->next;
    }
    
    //sonderfall
    //1.Element ist das gesuchte:
    if (temp->prev == NULL)
    {
        if(temp == liste->ende)
        {
            free(*temp);
            liste->ende = NULL;
            liste->anfang = NULL;
            printf("\t\t\tDatensatz %s geloescht!\n", remove);
            return 1;
        }
        liste->anfang = liste->anfang->next;
        free(liste->anfang->prev);
        liste->anfang->prev = NULL;
        
        printf("\t\t\tDatensatz %s geloescht!\n", remove);
        return 1;
    }
    
    
    if(temp != liste->ende)
    {
            
        temp->prev->next = temp->next;
        temp->next->prev = temp->prev;
        
        free(*temp);
        
        liste->aktuell = NULL;              //????????????????????????????????????
    }
    else
    {
        liste->ende = temp->prev;
        liste->ende->next = NULL;
        
        free(*temp);
    }
    
    
    printf("\t\t\tDatensatz %s geloescht!\n", remove);
    return 1;
}





/*******************************

            LADEN             
    
********************************/

void laden(t_liste *liste)
{
    FILE *fp;
    
    if( (fp = fopen("fh-datenbank.txt", "r")) != NULL )
    {
        while(feof(fp)==0)
        {
            t_daten *temp;
            temp = (t_daten*) malloc(sizeof(t_daten));
            
            if ( fscanf(fp, "%s %s %s %s %s",   temp->matrikelnummer, temp->nachname,
                                                temp->vorname, temp->email, temp->telefon )       !=     EOF )
            {
                einfuegen(temp, liste);
            }
            
            free(*temp);
        }
    }
    else
    {
        printf("\t\t\tFehler beim Einlesen der Datenbank!\n");
        return;
    }
    fclose(fp);
    printf("\t\t\tDatenbank eingelesen.\n");
    return;
}




/*******************************

            SPEICHERN             
    
********************************/

void speichern(t_liste *liste)
{
    FILE *fp;
    
    t_listElem *temp;
    temp = liste->anfang;
    
    if( (fp = fopen("fh-datenbank.txt", "w")) != NULL )
    {
        while(temp != NULL)
        {
            fprintf(fp, "%s %s %s %s %s\n", temp->daten->matrikelnummer, temp->daten->nachname, 
                                            temp->daten->vorname, temp->daten->email, temp->daten->telefon );
            
            temp = temp->next;
        }
    }
    else
        printf("\t\t\tFehler beim Speichern!\n");
    fclose(fp);
}






/*******************************

            AUSGABE             
    
********************************/

void printListe(t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    printf("\n\t\tInhalt der Datenbank:\n\n");
    if(temp == NULL)
        printf("\t\t\tLEER\n");
    while(temp != NULL)
    {
        printf("%8s\t%14s\t%10s\t%10s\t%12s\n", temp->daten->matrikelnummer, temp->daten->nachname, 
                                                temp->daten->vorname,  temp->daten->email, temp->daten->telefon );
        temp = temp->next;
    }
    printf("\n\n");
}




/*******************************

            ERZEUGEN             
    
********************************/

int createList(t_liste **liste)
{
    *liste = (t_liste*) malloc(sizeof(t_liste));
    
    if( *liste == NULL )
        return 0;
    
    (*liste)->anfang = NULL;
    (*liste)->aktuell = NULL;
    (*liste)->ende = NULL;
    return 1;
}






/*******************************

            EINLOGEN             
    
********************************/

int einlogen(char *mnummer, t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    
    while(temp != NULL)
    {
        if( strcmp(temp->daten->matrikelnummer, mnummer) == 0 )
        {
            liste->aktuell = temp;
            return 1;
        }
        temp = temp->next;
    }
    return 0;
}



/*******************************

            VORHANDEN             
    
********************************/

int vorhanden(char *mnummer, t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    
    while(temp != NULL)
    {
        if( strcmp(temp->daten->matrikelnummer, mnummer) == 0 )
            return 1;
        temp = temp->next;
    }
    return 0;
}




/*******************************

            AUSLOGEN             
    
********************************/

void auslogen(t_liste *liste)
{
    liste->aktuell = NULL;
}







void printKlausurAnmeldungen(t_daten *daten)
{
    int i=0;
    
    printf("bisher angemeldet bei:\n");
    if(daten->anz > 0)
    {
        while(i < daten->anz)
        {
            i++;
            switch(daten->klausur[i-1])
            {
                case 0:
                    printf("\t\t\tETECH\n");
                    break;
                case 1:
                    printf("\t\t\tPROG2\n");
                    break;
                case 2:
                    printf("\t\t\tIGRU\n");
                    break;
                case 3:
                    printf("\t\t\tANLI\n");
                    break;
            }       
        }
    }
    else
    {
        printf("\t\t\tkeiner Klausur\n");
    }
    printf("\n\n\n");
}

void klausurAnmeldung(int fach, t_daten *daten)
{
    int i;
    
    i = (daten->anz) - 1;
    
    while(i >= 0)
    {
        if(daten->klausur[i] == fach)
        {
            printf("\tFuer dieses Fach bist du schon angemeldet!\n");
            return;
        }
        i++;
    }
    daten->klausur[daten->anz] = fach;
    daten->anz += 1;
    switch(fach)
    {
        case 0:
            printf("\tErfolgreich zu ETECH angemeldet\n");
            break;
        case 1:
            printf("\tErfolgreich zu PROG2 angemeldet\n");
            break;
        case 2:
            printf("\tErfolgreich zu IGRU angemeldet\n");
            break;
        case 3:
            printf("\tErfolgreich zu ANLI angemeldet\n");
            break;
    }
    printf("\n\n\n");
    return;
}

void klausurAbmeldung(int fach, t_daten *daten)
{
    int i=0;
    
    
    for (i=0; i < daten->anz; i++)
    {
        if (daten->klausur[i] == fach)
        {
            daten->klausur[i] = NICHTANGEMELDET;
            daten->anz -= 1;
        }
    }
    switch(fach)
    {
        case 0:
            printf("\tErfolgreich von ETECH abgemeldet\n");
            break;
        case 1:
            printf("\tErfolgreich von PROG2 abgemeldet\n");
            break;
        case 2:
            printf("\tErfolgreich von IGRU abgemeldet\n");
            break;
        case 3:
            printf("\tErfolgreich von ANLI abgemeldet\n");
            break;
    }
    printf("\n\n\n");
    return;
}
