/**************************
 *      FH-DATENBANK      *
 *          von           *
 *  Andreas Zimmerschitt  *
 *************************/
 


/*      INCLUDES        */
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <time.h>


/*      DEFINES         */
#define KLAUSURENANZAHL     4

#define NICHTANGEMELDET     -1
#define PROGEINS       0
#define PROGZWEI       1
#define IGRU        2
#define ANLI        3




/*      DATENSTRUKTUREN     */
typedef struct{
    char matrikelnummer[20];
    char vorname[25];
    char nachname[25];
    char email[30];
    char telefon[25];
    int anz;
    int klausur[KLAUSURENANZAHL];
}t_daten;

typedef struct listElem{
    t_daten *daten;
    struct listElem *prev;
    struct listElem *next;
}t_listElem;

typedef struct{
    t_listElem *anfang;
    t_listElem *aktuell;
}t_liste;



/*      PROTOTYPEN      */
int einlogen(char *mnummer, t_liste *liste);

void auslogen(t_liste *liste);

void klausurAnmeldung(int fach, t_daten *daten);

void klausurAbmeldung(int fach, t_daten *daten);

void laden(t_liste *liste);

void speichern(t_liste *liste);

void einfuegen(t_daten *neuedaten, t_liste *liste);

int eingeben(t_liste *liste);

int vorhanden(char *mnummer, t_liste *liste);

int loeschen(char *mnummer, t_liste *liste);

int createList(t_liste **liste);

void printKlausurAnmeldungen(t_daten *daten);

void printListe(t_liste *liste);

void setcolor(unsigned short color);

void logo(void);





/*      MAIN        */
main()
{
    char auswahl, nummer[20];
    int done = 0, angemeldet, login, i, fach;
    t_liste *meineliste;
    
    
    if(!createList(&meineliste))
        return;
     
    
    
    //mainloop
    while(!done)
    {
        printf("\n\n\n\t\t\t");setcolor(12);
        printf("Administor Ebene");setcolor(8);printf("\n\n");
        printf("\t ");setcolor(4);printf("B");setcolor(8);printf("  Benutzer Ebene\n");
        printf("\t ");setcolor(4);printf("L");setcolor(8);printf("  Datenbank Laden\n");
        printf("\t ");setcolor(4);printf("S");setcolor(8);printf("  Datenbank Speichern\n");
        printf("\t ");setcolor(4);printf("N");setcolor(8);printf("  Neuen Datensatz anlegen\n");
        printf("\t ");setcolor(4);printf("D");setcolor(8);printf("  Datensatz Loeschen\n");
        printf("\t ");setcolor(4);printf("P");setcolor(8);printf("  Datenbank Ausgeben\n");
        printf("\t ");setcolor(4);printf("0");setcolor(8);printf("  Programm verlassen\n\n\n\n\n\n\n");
        
        auswahl = getch();
        
        if( isupper(auswahl) )
            auswahl = tolower(auswahl);
        
        switch(auswahl)
        {
            case 'l':
            {
                laden(meineliste);
                break;
            }
            case 's':
            {
                speichern(meineliste);
                break;
            }
            case 'p':
            {
                printListe(meineliste);
                break;
            }
            case 'd':
            {
                setcolor(7);printf("\tBitte Matrikelnummer des zu loeschenden Datensatzes eingeben: ");
                setcolor(15);
                
                scanf("%s", nummer);setcolor(7);
                
                loeschen(nummer, meineliste);
                break;
            }
            case '0':
            {
                done = 1;
                break;
            }
            case 'n':
            {
                i=0;
                do{ 
                    i++;
                    if(i == 3)
                    {
                        setcolor(8);
                        printf("\n\t\t");setcolor(4);
                        printf("Letzter Versuch!");setcolor(8);
                        printf("\n");
                    }
                }while( (i < 4) && (eingeben(meineliste)==0) );
                break;
            }
            case 'b':
            {
                angemeldet = 1;
                while(angemeldet)
                {
                    printf("\n\n\n\t\t\t");setcolor(12);
                    printf("Benutzer Ebene");setcolor(8);printf("\n\n");
                    printf("\t ");setcolor(4);printf("N");setcolor(8);printf("  Neuen Benutzer anlegen\n");
                    printf("\t ");setcolor(4);printf("L");setcolor(8);printf("  Benutzer einlogen\n");
                    printf("\t ");setcolor(4);printf("P");setcolor(8);printf("  Benutzerliste Ausgeben\n");
                    printf("\t ");setcolor(4);printf("0");setcolor(8);printf("  zurueck\n\n\n\n\n\n\n");
                    
                    auswahl = getch();
                    
                    switch(auswahl)
                    {
                        case 'n':
                        {
                            i=0;
                            do{ i++;
                                if(i == 3)
                                {
                                    setcolor(8);
                                    printf("\n\t\t");setcolor(4);
                                    printf("Letzter Versuch!");setcolor(8);
                                    printf("\n");
                                }
                            }while( (i < 4) && (eingeben(meineliste)==0) );
                            break;
                        }
                        case 'p':
                        {
                            printListe(meineliste);
                            break;
                        }
                        case '0':
                        {
                            angemeldet = 0;
                            break;
                        }
                        case 'l':
                        {
                            printf("\n\n\n\n\t\t\t");setcolor(12);
                            printf("BenutzerLogin");setcolor(7);printf("\n\n");
                            printf("\tBitte Matrikelnummer eingeben: ");
                            setcolor(15);
                            
                            scanf("%s", nummer);
                            
                            setcolor(7);
                                    
                            
                            if(einlogen(nummer, meineliste))
                            {
                                login = 1;
                                printf("\n\n\n\n\n\t\t ");setcolor(12);
                                printf("Willkommen %s %s!",  meineliste->aktuell->daten->vorname,
                                                                    meineliste->aktuell->daten->nachname );
                                setcolor(7);printf("\n\n");
                                while(login)
                                {
                                    setcolor(7);printf("\t\tWelche Aktion moechtest du ausfuehren?\n\n");
                                    
                                    printf("\t ");setcolor(4);printf("N");setcolor(8);printf("  Klausuranmeldung\n");
                                    printf("\t ");setcolor(4);printf("B");setcolor(8);printf("  Klausurabmeldung\n");
                                    printf("\t ");setcolor(4);printf("P");setcolor(8);printf("  Angemeldete Klausuren\n");
                                    printf("\t ");setcolor(4);printf("0");setcolor(8);printf("  Auslogen\n\n\n\n\n\n\n");
                                    
                                    auswahl = getch();
                                    
                                    switch(auswahl)
                                    {
                                        case '0':
                                        {
                                            auslogen(meineliste);
                                            login = 0;
                                            break;
                                        }
                                        case 'p':
                                        {
                                            printKlausurAnmeldungen(meineliste->aktuell->daten);
                                            break;
                                        }
                                        case 'n'://anmeldung
                                        {
                                            printf("\n\n\n\n\n\n");
                                            printf("\t ");setcolor(4);printf("1");setcolor(8);printf("  Programmieren 1\n");
                                            printf("\t ");setcolor(4);printf("2");setcolor(8);printf("  Programmieren 2\n");
                                            printf("\t ");setcolor(4);printf("3");setcolor(8);printf("  Grundlagen der Informatik\n");
                                            printf("\t ");setcolor(4);printf("4");setcolor(8);printf("  Analysis und Lineare Algebra\n");
                                            printf("\t ");setcolor(4);printf("0");setcolor(8);printf("  keine\n\n");
                                            setcolor(7);printf("\tBitte Nummer der Klausur eingeben: ");
                                            
                                            setcolor(15);
                                            scanf("%d", &fach);
                                            setcolor(7);
                                            if(fach != 0)
                                                klausurAnmeldung((fach-1), meineliste->aktuell->daten);
                                            printf("\n\n\n");
                                            break;
                                        }
                                        case 'b'://abmeldung
                                        {
                                            printf("\n\n\n\n\n\n");
                                            printf("\t ");setcolor(4);printf("1");setcolor(8);printf("  Programmieren 1\n");
                                            printf("\t ");setcolor(4);printf("2");setcolor(8);printf("  Programmieren 2\n");
                                            printf("\t ");setcolor(4);printf("3");setcolor(8);printf("  Grundlagen der Informatik\n");
                                            printf("\t ");setcolor(4);printf("4");setcolor(8);printf("  Analysis und Lineare Algebra\n");
                                            printf("\t ");setcolor(4);printf("0");setcolor(8);printf("  keine\n\n");
                                            setcolor(7);printf("\tBitte Nummer der Klausur eingeben: ");
                                            
                                            setcolor(15);
                                            scanf("%d", &fach);
                                            setcolor(7);
                                            
                                            if(fach != 0)
                                                klausurAbmeldung((fach-1), meineliste->aktuell->daten);
                                            printf("\n\n\n");
                                            break;
                                        }
                                    }//end switch
                                }//while(login)
                            }
                            else
                            {
                                printf("\t");setcolor(4);printf("Login fehlgeschlagen");setcolor(7);printf("!\n");
                            }
                            break;
                        }
                    }//end switch
                }//while(angemeldet)
                break;
            }
        }//end switch
    }//while(done)
    logo();
    
}






/*******************************

            EINLOGEN             
    
********************************/

int einlogen(char *mnummer, t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    
    while(temp != NULL)
    {
        if( strcmp(temp->daten->matrikelnummer, mnummer) == 0 )
        {
            liste->aktuell = temp;
            return 1;
        }
        temp = temp->next;
    }
    return 0;
}





/*******************************

            AUSLOGEN             
    
********************************/

void auslogen(t_liste *liste)
{
    liste->aktuell = NULL;
    printf("\n\n\t\t\t");setcolor(4);
    printf("Ausgeloggt");setcolor(7);
    printf("\n\n");
    return;
}





/*******************************

            ANMELDUNG             
    
********************************/

void klausurAnmeldung(int fach, t_daten *daten)
{
    
    if(daten->klausur[fach] == fach)
    {
        printf("\n\t");setcolor(4);printf("Fuer dieses Fach bist du schon angemeldet!");setcolor(7);printf("\n");
        printf("\n\n\n");
        return;
    }
    
    daten->klausur[fach] = fach;
    daten->anz += 1;
    switch(fach)
    {
        case PROGEINS:
            printf("\n\tErfolgreich zu ");setcolor(15);printf("Programmieren 1");setcolor(7);printf(" angemeldet\n");
            break;
        case PROGZWEI:
            printf("\n\tErfolgreich zu ");setcolor(15);printf("Programmieren 2");setcolor(7);printf(" angemeldet\n");
            break;
        case IGRU:
            printf("\n\tErfolgreich zu ");setcolor(15);printf("Grundlagen der Informatik");setcolor(7);printf(" angemeldet\n");
            break;
        case ANLI:
            printf("\n\tErfolgreich zu ");setcolor(15);printf("Analysis und Lineare Algebra");setcolor(7);printf(" angemeldet\n");
            break;
    }
    return;
}



/*******************************

            ABMELDUNG             
    
********************************/

void klausurAbmeldung(int fach, t_daten *daten)
{
    
    if(daten->klausur[fach] == fach)
    {
        daten->klausur[fach] = NICHTANGEMELDET;
        daten->anz -= 1;
    
        switch(fach)
        {
            case PROGEINS:
                printf("\n\tErfolgreich von ");setcolor(15);printf("Programmieren 1");setcolor(7);printf(" abgemeldet\n");
                break;
            case PROGZWEI:
                printf("\n\tErfolgreich von ");setcolor(15);printf("Programmieren 2");setcolor(7);printf(" abgemeldet\n");
                break;
            case IGRU:
                printf("\n\tErfolgreich von ");setcolor(15);printf("Grundlagen der Informatik");setcolor(7);printf(" abgemeldet\n");
                break;
            case ANLI:
                printf("\n\tErfolgreich von ");setcolor(15);printf("Analysis und Lineare Algebra");setcolor(7);printf(" abgemeldet\n");
                break;
        }
    }
    else
    {
        printf("\n\t");setcolor(4);printf("Du warst noch gar nicht angmeldet!");setcolor(7);printf("\n");
    }
    
    return;
}




/*******************************

            LADEN             
    
********************************/

void laden(t_liste *liste)
{
    FILE *fp;
    int i;
    
    if( (fp = fopen("fh-datenbank.txt", "r")) != NULL )
    {
        while(feof(fp)==0)
        {
            t_daten *temp;
            temp = (t_daten*) malloc(sizeof(t_daten));  //speicherplatz fr datenelement reservieren
            if ( temp == NULL )
            {   
                printf("\t\t\t");setcolor(4);
                printf("Fehler bei der Speicherreservierung!!!");setcolor(7);
                printf("\n");
                return;
            }
            if ( fscanf(fp, "%s %s %s %s %s %d",   temp->matrikelnummer, temp->nachname,
                                                temp->vorname, temp->email, temp->telefon,
                                                &(temp->anz) )       !=     EOF )
            {
                for(i=0; i < KLAUSURENANZAHL; i++)
                    fscanf(fp, " %d", &(temp->klausur[i]));
                
                
                einfuegen(temp, liste);
            }
        }
    }
    else
    {
        printf("\t\t\t");setcolor(4);
        printf("Fehler beim Einlesen der Datenbank!");setcolor(7);
        printf("\n");
        return;
    }
    fclose(fp);
    printf("\t\t\t");setcolor(4);
    printf("Datenbank eingelesen.");setcolor(7);
    printf("\n");
    return;
}




/*******************************

            SPEICHERN             
    
********************************/

void speichern(t_liste *liste)
{
    FILE *fp;
    int i;
    
    t_listElem *temp;
    temp = liste->anfang;
    
    if( (fp = fopen("fh-datenbank.txt", "w")) != NULL )
    {
        while(temp != NULL) //wenn temp == NULL ist liste->ende erreicht
        {
            fprintf(fp, "%s %s %s %s %s %d ", temp->daten->matrikelnummer, temp->daten->nachname, 
                                            temp->daten->vorname, temp->daten->email,
                                            temp->daten->telefon, temp->daten->anz );
            for(i=0; i < KLAUSURENANZAHL; i++)
                fprintf(fp, "%d ", temp->daten->klausur[i]);
            
            fprintf(fp, "\n");
            temp = temp->next;  //zeiger auf nchstes listenelement
        }
        printf("\t\t\t");setcolor(4);
        printf("Datenbank erfolgreich gespeichert!");setcolor(7);
        printf("\n");
    }
    else
    {
        printf("\t\t\t");setcolor(4);
        printf("Fehler beim Speichern!");setcolor(7);
        printf("\n");
    }
    fclose(fp);
}

/*******************************

            EINFGEN             
    
********************************/

void einfuegen(t_daten *neuedaten, t_liste *liste)
{
    t_listElem *neu;
    neu = (t_listElem*) malloc(sizeof(t_listElem));
    if ( neu == NULL )
    {   
        printf("\t\t\t");setcolor(4);
        printf("Fehler bei der Speicherreservierung!!!");setcolor(7);
        printf("\n");
        return;
    }
    
    neu->daten = neuedaten;
    neu->next = NULL;
    neu->prev = NULL;
            
    
    if(liste->anfang == NULL)
    {
        //noch nichts in der Liste vorhanden
        liste->anfang = neu;
    }
    else
    {
        neu->next = liste->anfang;
        liste->anfang->prev = neu;
        liste->anfang = neu;   
    }
}

/*******************************

            EINGEBEN             
 
********************************/


int eingeben(t_liste *liste)
{
    int i;
    t_daten *temp;
    
    temp = (t_daten*) malloc(sizeof(t_daten));  //speicherplatz fr datenelement reservieren

    if ( temp == NULL )
    {   
        printf("\t\t\t");setcolor(4);
        printf("Fehler bei der Speicherreservierung!!!");setcolor(7);
        printf("\n");
        return;
    }
    
    setcolor(7);printf("\n\nBitte Matrikelnummer, Vorname, Nachname, email, telefon  eingeben\n\n");
    setcolor(15);
    
    scanf("%s %s %s %s %s", temp->matrikelnummer, temp->vorname,
                            temp->nachname, temp->email, temp->telefon );
     
    setcolor(7);                              
    
    //wenn benutzer schon in liste vorhanden, abbruch
    if(vorhanden(temp->matrikelnummer, liste))
    {
        printf("\t\t");setcolor(4);
        printf("Kein Erfolg! Benutzer schon vorhanden!");setcolor(7);printf("\n");
        free(temp); //speicherplatz wieder freigeben
        return 0;
    }
    
    
    temp->anz = 0;
    
    for(i=0; i < KLAUSURENANZAHL; i++)
    {
        temp->klausur[i] = NICHTANGEMELDET;
    }
    //neuen benutzer in liste eintragen
    einfuegen(temp, liste);
    
    return 1;
}





/************************************

            VORHANDEN?             
 
*************************************/

int vorhanden(char *mnummer, t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    
    while(temp != NULL) //ende erreicht?
    {
        if( strcmp(temp->daten->matrikelnummer, mnummer) == 0 )
            return 1;
        temp = temp->next;
    }
    return 0;
}





/*******************************

            LSCHEN             
    
********************************/


int loeschen(char *remove, t_liste *liste)
{
    t_listElem *temp;
    
    temp = liste->anfang;
    
    //sonderfall Datenbank leer
    if(temp == NULL)
    {
        printf("\n\n\t\t\t");setcolor(4);
        printf("Datenbank ist leer! Loeschen nicht moeglich!");setcolor(7);
        printf("\n");
        return 0;
    }
    
    
    //suchen bis Matrikelnummer gefunden
    while( strcmp( temp->daten->matrikelnummer, remove ) != 0 )
    {
        //listenende erreicht?
        if (temp->next == NULL)
        {
            printf("\n\n\t\t\t");setcolor(4);
            printf("Matrikelnummer nicht gefunden!");setcolor(7);
            printf("\n");
            return 0;
        }
        //sonst ein listenelement weiter
        temp = temp->next;
    }
    
    //1.Element ist das gesuchte:
    if (temp->prev == NULL)
    {
        liste->anfang = liste->anfang->next;
        //wenn anfang nicht einziges element war
        if(liste->anfang != NULL)   
            liste->anfang->prev = NULL;
        free(temp);
    }
    else
    {
        //es gibt noch nachfolger
        if(temp->next != NULL)
        {
                
            temp->prev->next = temp->next;
            temp->next->prev = temp->prev;
            free(temp);
        }
        //letztes element
        else
        {
            temp->prev->next = NULL;
            free(temp);
        }
    }
    
    printf("\n\t\t\t");setcolor(4);
    printf("Datensatz");setcolor(15);
    printf(" %s ", remove);setcolor(4);
    printf("geloescht!");setcolor(7);
    printf("\n");
    return 1;
}






/*******************************

        DATENBANK ERZEUGEN             
    
********************************/

int createList(t_liste **liste)     //pointer auf [pointer auf t_liste]
{
    *liste = (t_liste*) malloc(sizeof(t_liste));
    
    if( *liste == NULL )
        return 0;
    
    (*liste)->anfang = NULL;
    (*liste)->aktuell = NULL;
    return 1;
}









/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//            AB HIER NUR FUNKTIONEN ZUR AUSGABE                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////





/*******************************

            AUSGABE KLAUSUREN             
    
********************************/

void printKlausurAnmeldungen(t_daten *daten)
{
    int i;
    
    setcolor(7);
    printf("\n\n\n\n\tbisher angemeldet bei:\n\n");
    if(daten->anz > 0)
    {
        for( i=0; i < KLAUSURENANZAHL ; i++)
        {
            switch(daten->klausur[i])
            {
                case PROGEINS:
                    printf("\t\t\t- ");setcolor(15);printf("Programmieren 1");setcolor(7);printf("\n");
                    continue;
                case PROGZWEI:
                    printf("\t\t\t- ");setcolor(15);printf("Progammieren 2");setcolor(7);printf("\n");
                    continue;
                case IGRU:
                    printf("\t\t\t- ");setcolor(15);printf("Grundlagen der Informatik");setcolor(7);printf("\n");
                    continue;
                case ANLI:
                    printf("\t\t\t- ");setcolor(15);printf("Ananlysis und Lineare Algebra");setcolor(7);printf("\n");
                    continue;
            }       
        }
    }
    else
    {
        printf("\t\t\t");setcolor(15);printf("keiner Klausur");setcolor(7);printf("\n");
    }
    printf("\n\n\n");
}






/*******************************

        DATENBANK AUSGABE             
    
********************************/

void printListe(t_liste *liste)
{
    t_listElem *temp;
    int i;
    char side = 186, upperRight = 187, lowerRight = 188, lowerLeft = 200, upperLeft = 201,
         mide = 205, up = 202, down = 203, cross = 206, crossLeft = 204, crossRight = 185;
       
    temp = liste->anfang;
    setcolor(7);printf("\n\t\tInhalt der Datenbank:");
    setcolor(0); printf("\n\n");
    
    setcolor(135); printf("%c", upperLeft);
        for (i=0; i<10; i++){
            printf("%c", mide);}
        printf("%c", down);
        for (i=0; i<12; i++){
            printf("%c", mide);}
        printf("%c", down);
        for (i=0; i<17; i++){
            printf("%c", mide);}
        printf("%c", down);
        for (i=0; i<17; i++){
            printf("%c", mide);}
        printf("%c", down);
        for (i=0; i<17; i++){
            printf("%c", mide);}
    printf("%c", upperRight);
    setcolor(0);printf("\n");
    
    while(temp != NULL)
    {
        setcolor(135); printf("%c", side);
    
        setcolor(143); printf(" %8s", temp->daten->matrikelnummer );
        setcolor(135); printf(" %c", side );
        setcolor(143); printf(" %10s", temp->daten->vorname );
        setcolor(135); printf(" %c", side );
        setcolor(143); printf(" %15s", temp->daten->nachname );
        setcolor(135); printf(" %c", side );
        setcolor(143); printf(" %15s", temp->daten->email );
        setcolor(135); printf(" %c", side );
        setcolor(143); printf(" %15s", temp->daten->telefon );
        setcolor(135); printf(" %c", side);
        setcolor(0); printf("\n");
        if(temp->next != NULL)
        {
            setcolor(135);
            printf("%c", crossLeft);
            for (i=0; i<10; i++){
                printf("%c", mide);}
            printf("%c", cross);
            for (i=0; i<12; i++){
                printf("%c", mide);}
            printf("%c", cross);
            for (i=0; i<17; i++){
                printf("%c", mide);}
            printf("%c", cross);
            for (i=0; i<17; i++){
                printf("%c", mide);}
            printf("%c", cross);
            for (i=0; i<17; i++){
                printf("%c", mide);}
            printf("%c", crossRight);
            
            setcolor(0);printf("\n");
        }
        temp = temp->next;
    }
    
    setcolor(135); printf("%c", lowerLeft);
    for (i=0; i<10; i++){
        printf("%c", mide);}
    printf("%c", up);
    for (i=0; i<12; i++){
        printf("%c", mide);}
    printf("%c", up);
    for (i=0; i<17; i++){
        printf("%c", mide);}
    printf("%c", up);
    for (i=0; i<17; i++){
        printf("%c", mide);}
    printf("%c", up);
    for (i=0; i<17; i++){
        printf("%c", mide);}
    printf("%c", lowerRight);
    setcolor(0); printf("\n\n");
    setcolor(8);printf("\t\t\t\t\t\tenter -> weiter zum menue\n\n");
    getch();
}






/* nur zur Farbgebung */
void setcolor(unsigned short color)
{
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleTextAttribute(hcon,color);
}


/*    Logoausgabe       */ 
void logo(void)
{
    char side = 186, upperRight = 187, lowerRight = 188, lowerLeft = 200, upperLeft = 201, mide = 205;
    int i;
    time_t t1, t2;
    
    setcolor(0); printf("\n\n\t\t\t");
    setcolor(135); printf("%c", upperLeft);
    for (i=0; i<15; i++){
        printf("%c", mide);}
    printf("%c", upperRight);
    
    setcolor(0); printf("\n\t\t\t");
    setcolor(135); printf("%c", side);
    for (i=0; i<15; i++){
        printf(" ");}
    printf("%c", side);
    
    setcolor(0); printf("\n\t\t\t");
    setcolor(135); printf("%c", side);
    setcolor(143); printf(" www.impius.de ");
    setcolor(135); printf("%c", side);
    
    setcolor(0); printf("\n\t\t\t");
    setcolor(135); printf("%c", side);
    for (i=0; i<15; i++){
        printf(" ");}
    printf("%c", side);
    
    setcolor(0); printf("\n\t\t\t");
    setcolor(135); printf("%c", lowerLeft);
    for (i=0; i<15; i++){
        printf("%c", mide);}
    printf("%c", lowerRight);
    setcolor(0); printf("\n\n");
    
    time(&t1);
    do{
        time(&t2);
    }while( difftime( t2, t1) < 0.0 );
}







