#include <stdio.h>
#include <conio.h>

typedef struct listElem{
    int wert;
    struct listElem *prev;
    struct listElem *next;
}t_listElem;

typedef struct{
    t_listElem *anfang;
    t_listElem *ende;
}t_liste;


int createList(t_liste **liste);
void einfuegen(int element, t_liste *liste);
int loeschen(int element, t_liste *liste);
void printListe(t_liste *liste);



main()
{
    t_liste *meineliste;
    
    if( createList(&meineliste) )
    {    
        einfuegen(1, meineliste);
        einfuegen(2, meineliste);
        einfuegen(3, meineliste);
        printListe(meineliste);
        loeschen(3, meineliste);
        printListe(meineliste);
    }
    
    getch();
}



int createList(t_liste **liste)
{
    *liste = (t_liste*) malloc(sizeof(t_liste));
    
    if( *liste == NULL )
        return 0;
    
    (*liste)->anfang = NULL;
    (*liste)->ende = NULL;
    return 1;
}



void einfuegen(int element, t_liste *liste)
{
    t_listElem *temp;
    
    t_listElem *neu;
    neu = (t_listElem*) malloc(sizeof(t_listElem));
    
    neu->wert = element;
    neu->next = NULL;
    neu->prev = NULL;
    
    printf("%d einfuegen\n", element);
    
    if(liste->anfang == NULL && liste->ende == NULL)
    {
        //noch nichts in der Liste vorhanden
        liste->anfang = neu;
        liste->ende = neu;
        return;
    }
    else
    {
        //wenn nur ein element vorhanden ist,
        //platz suchen und anfang oder ende versetzen
        if(liste->anfang == liste->ende)
        {
            if(liste->anfang->wert < neu->wert)
            {
                neu->prev = liste->anfang;
                liste->anfang->next = neu;
                liste->ende = neu;
            }
            else
            {
                neu->next = liste->ende;
                liste->ende->prev = neu;
                liste->anfang = neu;
            }
        }
        //sonst mind zwei Elemente vorhanden.
        else
        {            
            temp = liste->anfang;
            
            
            if(neu->wert <= liste->anfang->wert)
            {
                //vorne einfgen
                neu->next = liste->anfang;
                liste->anfang->prev = neu;
                liste->anfang = neu;
                return;
            }
            
            
            if(neu->wert >= liste->ende->wert)
            {
                //hinten einfgen
                neu->prev = liste->ende;
                liste->ende->next = neu;
                liste->ende = neu;
                return;
            }
            
            //liste durchlaufen
            while(liste->anfang->wert < neu->wert)
                liste->anfang = liste->anfang->next;
            
            neu->prev = liste->anfang->prev;
            neu->next = liste->anfang;
            
            liste->anfang->prev->next = neu;
            liste->anfang->prev = neu;
            
            liste->anfang = temp;
        }
        return;
    }
}



int loeschen(int element, t_liste *liste)
{
    t_listElem *temp;
    t_listElem *deleteme;
    
    int i=0;
    
    //sonderfall
    if(liste->anfang->next == NULL)
    {
        printf("Liste ist leer! Loeschen nicht moeglich!\n");
        return 0;
    }
    
    temp = liste->anfang;
    
    //suchen bis element gefunden
    while(liste->anfang->wert != element)
    {
        //listenende erreicht?
        if (liste->anfang == liste->ende)
        {
            printf("Element nicht gefunden!\n");
            liste->anfang = temp;
            return 0;
        }
        //sonst ein listenelement weiter
        liste->anfang = liste->anfang->next;
    }
    
    //sonderfall
    //1.Element ist das gesuchte:
    if (liste->anfang->prev == NULL)
    {
        do{
            i++;
            //wenn listenende erreicht, aufhren
            if(liste->anfang == liste->ende)
            {
                free(liste->anfang);
                liste->anfang = NULL;
                liste->ende = NULL;
                break;
            }
            //sondt zeiger eins weiter schieben
            liste->anfang = liste->anfang->next;
            //vorgnger lschen
            free(liste->anfang->prev);
            liste->anfang->prev = NULL;
        }while(liste->anfang->wert == element); //sollte element mehrmals vorkommen
        
        printf("Erfolg! %d wurde %d mal geloescht!\n", element, i);
        return 1;
    }
    
    //element ist irgendwo (auch am ende)
    do{
        i++;
        if(liste->anfang != liste->ende)
        {
            deleteme = liste->anfang;
            //momentanes element berspringen vorgnger und nachfolger mitteilen
            liste->anfang->prev->next = liste->anfang->next;//vorgnger bekommt neuen nachfolger
            liste->anfang->next->prev = liste->anfang->prev;//nachfolger bekommt neuen vorgnger
            //momentanes element lschen
            free(liste->anfang);
            //eins weiter gehen
            liste->anfang = deleteme->next;
        }
        else
        {
            liste->ende = liste->anfang->prev;  //ende eins vor rcken
            liste->ende->next = NULL;       //und ins nichts zeigen
            free(liste->anfang);        //momentanes element lschen
            break;  
        }
    }while(liste->anfang->wert == element); //sollte element mehrmals vorkommen
    
    
    printf("Erfolg! %d wurde %d mal geloescht!\n", element, i);
    //wieder auf anfangsposition gehen
    liste->anfang = temp;
    return 1;
}


void printListe(t_liste *liste)
{
    t_listElem *temp;
    int i=0;
    
    temp = liste->anfang;
    printf("\nListe ausgeben:\n");
    while(temp != NULL)
    {
        printf("liste[%d] = %d\n", i, temp->wert);
        temp = temp->next;
        i++;
    }
}
