/**************************
 *   Fahrzeugverwaltung   *
 *          von           *
 *  Andreas Zimmerschitt  *
 *************************/



#include "fahrzeuge.h"

#include <iostream>
using namespace std;

/*fr Borland5
#inlcude <iostream.h>
*/


#define MAXFAHRZEUGANZAHL 100




///////////////////////// Fuhrpark /////////////////////////////////////
class Fuhrpark {
    protected:
        Fahrzeug *kfz[MAXFAHRZEUGANZAHL];
        int fahrzeuganzahl;
    
        void menu(void);
        void ausgabe_aller(void);
        void ausgabe_verfuegbar(void);
        void fahrzeug_eingabe(void);
        void fahrzeug_aendern(void);
        void fahrzeug_verleihen(void);
        void fahrzeug_rueckgabe(void);
        void fahrzeug_loeschen(void);
    public:
        Fuhrpark(int anzahl);
        ~Fuhrpark();
};





Fuhrpark::Fuhrpark(int anzahl)
{
    fahrzeuganzahl = 0;
    for (int i=0; i<anzahl; i++)
        kfz[i] = NULL;
    
    menu();
}




Fuhrpark::~Fuhrpark()
{
    int waitforinput;
    delete [] kfz;
    cout << "Fuhrpark zerstoert!!\n";
    cin >> waitforinput;
}





void Fuhrpark::ausgabe_aller(void)
{
    
    if (fahrzeuganzahl > 0)
    {
        int auswahl=1;
        cout << "\n\t Alle Fahrzeuge:\n\n";
        for (int i=0; i<fahrzeuganzahl; i++)
            cout << "Fahrzeug " << i+1 << ": "<< kfz[i]->name << "\n";
        
        do
        {
            cout << "\nBitte Fahrzeugnummer fuer Details angeben: (0 fuer weiter) ";
            cin >> auswahl;
            cout << "\n";
            if (auswahl>0 && auswahl<=fahrzeuganzahl)
                kfz[auswahl-1]->ausgabe();
            else
                auswahl = 0;
        }while (auswahl && fahrzeuganzahl > 1);
    }
    else
        cout << "\n\t Es befinden sich keine Fahrzeuge im Fuhrpark!\n";
    cout << "\n\n";
    return;
}





void Fuhrpark::ausgabe_verfuegbar(void)
{
    int anzahl=0;
    for (int i=0; i<fahrzeuganzahl; i++)
        anzahl += kfz[i]->ist_verfuegbar();
        
    if (anzahl > 0)
    {
        int auswahl=1;
        cout << "\n\t Alle verfuegbaren Fahrzeuge:\n";
        for (int i=0; i<fahrzeuganzahl; i++)
            if(kfz[i]->ist_verfuegbar())
                cout << "\nFahrzeug " << i+1 << ": " << kfz[i]->name << "\n";
        
        do
        {
            cout << "\nBitte Fahrzeugnummer fuer Details angeben: (0 fuer weiter) ";
            cin >> auswahl;
            cout << "\n";
            if (auswahl>0 && auswahl<=fahrzeuganzahl)
                kfz[auswahl-1]->ausgabe();
            else
                auswahl = 0;
        }while (auswahl && fahrzeuganzahl > 1);
    }
    else
        cout << "\n\t Momentan kein Fahrzeug verfuegbar!\n";
    cout << "\n\n";
    return;
}





void Fuhrpark::fahrzeug_eingabe(void)
{
    int fahrzeugtyp;
    cout << "\nWelches Fahrzeug soll hinzugefuegt werden? (1-8)\n";
    cout << "\t1\tCabrio\n";
    cout << "\t2\tLimosine\n";
    cout << "\t3\tKombi\n";
    cout << "\t4\tBus\n";
    cout << "\t5\tLKW\n";
    cout << "\t6\tAnhaenger fuer LKW\n";
    cout << "\t7\tAnhaenger fuer PKW\n";
    cout << "\t8\tWohnwagen\n";
    cin >> fahrzeugtyp;
    
    switch(fahrzeugtyp){
        case 1:
            try{
                kfz[fahrzeuganzahl] = new Cabrio;
            } catch (bad_alloc xa) {
                cerr << "Cabrio erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 2:
            try{
                kfz[fahrzeuganzahl] = new Limo;
            } catch (bad_alloc xa) {
                cerr << "Limosine erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 3:
            try{
                kfz[fahrzeuganzahl] = new Kombi;
            } catch (bad_alloc xa) {
                cerr << "Kombi erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 4:
            try{
                kfz[fahrzeuganzahl] = new Bus;
            } catch (bad_alloc xa) {
                cerr << "Bus erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 5:
            try{
                kfz[fahrzeuganzahl] = new LKW;
            } catch (bad_alloc xa) {
                cerr << "LKW erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 6:
            try{
                kfz[fahrzeuganzahl] = new LKW_Anhaenger;
            } catch (bad_alloc xa) {
                cerr << "LKW-Anhaenger erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 7:
            try{
                kfz[fahrzeuganzahl] = new PKW_Anhaenger;
            } catch (bad_alloc xa) {
                cerr << "PKW-Anhaenger erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        case 8:
            try{
                kfz[fahrzeuganzahl] = new Wohnwagen;
            } catch (bad_alloc xa) {
                cerr << "Wohnwagen erzeugen fehlgeschlagen!!\n";
                break;
            }
            fahrzeuganzahl++;
            break;
        default:
            cerr << "Eingabe nicht korrekt!\n";
            break;
    }
    cout << "\n\n";
    return;
}





void Fuhrpark::fahrzeug_aendern()
{
    if (fahrzeuganzahl > 0)
    {
        int auswahl;
        cout << "Welches Fahrzeug soll geaendert werden? (Bitte Nummer angeben! 1-" 
                << fahrzeuganzahl << ")\n";
        cin >> auswahl;
        
        kfz[auswahl-1]->aendern();
        
        cout << kfz[auswahl-1]->name << " wurde geaendert.\n\n";
    }
    else
        cout << "Es befinden sich keine Fahrzeuge im Fuhrpark!\nAendern nicht moeglich!\n";
    return;
}





void Fuhrpark::fahrzeug_verleihen(void)
{
    if (fahrzeuganzahl > 0)
    {
        int auswahl;
        cout << "Welches Fahrzeug soll verliehen werden? (Bitte Nummer angeben! 1-" 
                << fahrzeuganzahl << ")\n";
        cin >> auswahl;
        
        kfz[auswahl-1]->verleihen();
        cout << kfz[auswahl-1]->name << " wurde verliehen.\n\n";
    }
    else
        cout << "Es befinden sich keine Fahrzeuge im Fuhrpark!\nVerleihen nicht moeglich!\n";
    return;
}






void Fuhrpark::fahrzeug_rueckgabe(void)
{
    char zurueck[32];
    
    cout << "Was moechten Sie zurueckgeben? (Bitte Namen angeben) \n";
    cin >> zurueck;
    
    for (int i=0; i<fahrzeuganzahl; i++)
    {
        
        if( strcmp(zurueck, kfz[i]->name) == 0)
        {
            kfz[i]->rueckgabe();
            cout << zurueck << " ist nicht gereinigt worden!\nDas macht nochmal 150 euro!\n\n";
            return;
        }
    }
    cout << zurueck << " befindet sich nicht in unserem Fuhrpark!\n\n";
    return;
}






void Fuhrpark::fahrzeug_loeschen(void)
{
    if(fahrzeuganzahl == 0)
        cout << "Es befindet sich kein Fahrzeug im Fuhrpark!\nLoeschen nicht moeglich!\n\n";
    else
    {
        int auswahl;
        char loeschen[32];
        cout << "Welches Fahrzeug soll geloescht werden? (Bitte Nummer angeben! 1-" 
                << fahrzeuganzahl << ") ";
        cin >> auswahl;
        
        strcpy(loeschen, kfz[auswahl-1]->name);
        kfz[auswahl-1] = kfz[--fahrzeuganzahl];
        delete kfz[fahrzeuganzahl];
        
        cout << loeschen << " erfolgreich geloescht!\n\n";
    }
    return;
}






void Fuhrpark::menu(void)
{
    char auswahl;
    int done=0;
    cout << "\tFuhrpark wird gestartet!\n\n";
    
    do
    {
        cout << "Bitte Treffen Sie Ihre Auswahl:\n\n";
        cout << "\t1\tFahrzeug hinzufuegen\n";
        cout << "\t2\tFahrzeug aendern\n";
        cout << "\t3\tFahrzeug verleihen\n";
        cout << "\t4\tFahrzeug zurueckgeben\n";
        cout << "\t5\tFahrzeug loeschen\n";
        cout << "\t6\tAusgabe aller verfuegbaren Fahrzeuge\n";
        cout << "\t7\tAusgabe aller Fahrzeuge im Furhpark\n";
        cout << "\t0\tFuhrpark verlassen\n";
        cin >> auswahl;
        
        switch(auswahl)
        {
            case '1':
                fahrzeug_eingabe();
                break;
            case '2':
                fahrzeug_aendern();
                break;
            case '3':
                fahrzeug_verleihen();
                break;
            case '4':
                fahrzeug_rueckgabe();
                break;
            case '5':
                fahrzeug_loeschen();
                break;
            case '6':
                ausgabe_verfuegbar();
                break;
            case '7':
                ausgabe_aller();
                break;
            case '0':
                done = 1;
                break;
            default:
                cout << "Keine gueltige Auswahl!\n\n";
        }
    }while(!done);
    return;
}



main()
{
    Fuhrpark Fpark(MAXFAHRZEUGANZAHL);
}

