/**************************
 *labyrinth ist 20x30 gro*
 *          von           *
 *  Andreas Zimmerschitt  *
 **************************/


#include <stdio.h>
#include <conio.h>
#include <windows.h>

#define MAX  50
#define WEG  -1


int sucheWeg(int feld[][], int dimX, int dimY, int posX, int posY);

int init(int feld[][], int dimX, int dimY);

void ausgabe(int feld[][], int dimX, int dimY);

void setcolor(unsigned short color);	//dient nur zur farbgebung



main()
{
    int dimX, dimY;
    int feld[MAX][MAX];
    
    printf("\n\t\t\t");
    setcolor(12);printf("Labyrinth");setcolor(7);
    printf("\n\n");
    
    
    // wenn init == 0, war die Eingabe der Dimensionen falsch
    do{
        printf("\tWie gross soll das Labyrinth werden? (zeile,spalte)\n");
        scanf("%d %d", &dimY, &dimX);
    }while( init(feld, dimX, dimY) == 0 );
    
    
    //beginne bei Startposition
    if( sucheWeg(feld, dimX, dimY, 0, 0) != 1 )
        printf("\tIch hab mich verlaufen und kann leider keinen Weg hinaus finden\n");
    
    getch();
}




int sucheWeg(int feld[MAX][MAX], int dimX, int dimY, int posX, int posY)
{
    //aktuelle Position als Weg kennzeichnen
    feld[posY][posX] = WEG;
    
    //nur zum verfolgen der wegstrecke
    /*
    ausgabe(feld, dimX, dimY);
    getch();
    */
    
    
    if( posX == dimX-1 && posY == dimY-1 )
    {
        //Erfolg! Aktuelle Position entspricht Zielkoordinaten.
        printf("\t\tWeg gefunden:\n");
        ausgabe(feld, dimX, dimY);
        return 1;
    }
    else
    {
        if( posY < dimY-1 )       //es darf kein "out of bounds" geben
            if( feld[posY+1][posX] == 0 )       //existiert ein Weg in diese Richtung?
                if( sucheWeg(feld, dimX, dimY, posX, posY+1) == 1)      //dann mache da weiter
                    return 1;       //damit Erfolg rekursiv zurckgemeldet werden kann
        
        if( posX < dimX-1 )
            if( feld[posY][posX+1] == 0 )
                if( sucheWeg(feld, dimX, dimY, posX+1, posY) == 1)
                    return 1;
        
        if( posY > 0 )
            if( feld[posY-1][posX] == 0 )
                if( sucheWeg(feld, dimX, dimY, posX, posY-1) == 1)
                    return 1;
        
        if( posX > 0 )
            if( feld[posY][posX-1] == 0 )
                if( sucheWeg(feld, dimX, dimY, posX-1, posY) == 1)
                    return 1;
        
        
        //keinen Weg gefunden oder schon mal da gewesen
        feld[posY][posX] = 0;   //lsche aktuelle Position
        return 0;               //und melde Mierfolg zurck
    }
    //sollte nie der Fall sein, aber sicher ist sicher...
    return 0;
}





int init(int feld[MAX][MAX], int dimX, int dimY)
{
    FILE *eingabe;
    int zeile, spalte;
    
    if ((eingabe = fopen("labyrint.def", "r")) != NULL) //Datei ffnen
    {
        for(zeile=0; zeile<dimY; zeile++)
        {
            for(spalte=0; spalte<dimX; spalte++)
            {
                if(fscanf(eingabe, "%1d", &feld[zeile][spalte]) != EOF)
                    ;  //wenn Dateiende noch nicht erreicht, labyrint einlesen
                else
                {   //Dateiende ist erreicht, aber noch nicht alle Zeilen und Spalten abgearbeitet.
                    printf("\tDie Dimensionen wurden falsch eingegeben!\n Bitte erneute Eingabe!\n\n");
                    fclose(eingabe);
                    return 0;
                }
            }
        }
        if(fscanf(eingabe, "%d", &zeile) != EOF)
        {
            //Dateiende ist nicht erreicht, aber alle Zeilen und Spalten sind abgearbeitet.
            printf("\tDie Dimensionen wurden falsch eingegeben!\n Bitte erneute Eingabe!\n\n");
            fclose(eingabe);
            return 0;
        }
    }
    else
        printf("\tFehler beim Oeffnen der Datei labyrint.def!\n");
    
    printf("\tDatei \"labyrint.def\" erfolgreich eingelesen.\n");
    ausgabe(feld, dimX, dimY);    //eingelesenes Labyrinth ausgeben
    printf("\t\tSuche mit Enter beginnen");
    getch();
    printf("\n\n");
    fclose(eingabe);
    return 1;
}



void ausgabe(int feld[MAX][MAX], int dimX, int dimY)
{
    int zeile, spalte;
    
    printf("\t\t");setcolor(136);printf("+");    //oberer Rahmen
    for(spalte=0; spalte<dimX; spalte++)
        printf("-");
    printf("+");setcolor(7);printf("\n");
    
    for(zeile=0; zeile<dimY; zeile++)
    {
        printf("\t\t");setcolor(136);printf("|");setcolor(7);    //linker Rahmen
        for(spalte=0; spalte<dimX; spalte++)
        {
            if(feld[zeile][spalte] == WEG)
            {
                setcolor(252);printf("o");setcolor(7);
            }
            if(feld[zeile][spalte] == 0)
            {
                setcolor(255);printf("%d", feld[zeile][spalte]);setcolor(7);
            }
            if(feld[zeile][spalte] == 1)
            {
                setcolor(119);printf("%d", feld[zeile][spalte]);setcolor(7);
            }
        }
        setcolor(136);printf("|");setcolor(7);printf("\n");    //rechter Rahmen
    }
    
    printf("\t\t");setcolor(136);printf("+");   //unterer Rahmen
    for(spalte=0; spalte<dimX; spalte++)
        printf("-");
    printf("+");setcolor(7);printf("\n\n");
    
    return;
}


void setcolor(unsigned short color)
{
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleTextAttribute(hcon,color);
}

