

#include "muster.h"

//Konstruktor
muster::muster(int pixel)
{
    this->size = pixel;
    
    try {
        x = new int[pixel];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: muster!\n";
        return;
    }
}


//Destruktor
muster::~muster(void)
{
    delete [] x;
    //cout << "Destruktor erfolgreich: Muster geloescht\n";    
}


//Copy-Konstruktor
muster::muster(const muster &m)
{
    size = m.size;
    
    try {
        x = new int[size];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: copy-muster!\n";
        return;
    }
    
    for(int i=0; i<size; i++)
        x[i] = m.x[i];
    //cout << "Kopie erzeugt!\n";
}



void muster::resize(int pixel)
{
    this->size = pixel;
    
    try {
        x = new int[pixel];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim ReAllozieren: muster!\n";
        return;
    }
}



int muster::compare_to(const muster &m)
{
    for(int i=0; i<size; i++)
        if(x[i] != m.x[i])
            return 0;
    
    return 1;
}


void muster::set(FILE *fp)
{
    int temp;
    for(int i=0; i<size; i++)
    {
        fscanf(fp, "%d", &temp);
        x[i] = konvert_bin_to_bip(temp);
    }
}



void muster::print()
{
    int i,k,p;
    for(i=0; i<size; i=i+4)
    {
        cout << "\t\t";
        for(k=i; k<i+4; k++)
        {
            if(( p = konvert_bip_to_bin( x[k]) ) == 0)
                setcolor(WHITE);
            else
                setcolor(BLACK);
            cout << " " << p;
        }
        setcolor(7);
        cout << "\n";
    }
    cout << "\n";
}




void setcolor(unsigned short color)
{
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleTextAttribute(hcon,color);
}

