
#include "neuron.h"


//Konstruktor
neuron::neuron(void)
{ 
    size = 2;
    
    try {
        in = new int[size];
        w = new int[size];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: neuron!\n";
        return;
    }
    
    for(int i=0; i<size; i++)
    { 
        in[i] = 0; 
        w[i] = 0; 
    }
    out = 0;  
}


//Destruktor
neuron::~neuron()
{
    delete [] in;
    delete [] w;
}


//Copy-Konstruktor
neuron::neuron(const neuron &n)
{
    size = n.size;
    
    try {
        in = new int[size];
        w = new int[size];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: copy-neuron!\n";
        return;
    }
    
    for(int i=0; i<size; i++)
    {
        in[i] = n.in[i];
        w[i] = n.w[i];
    }
    //cout << "Kopie von Neuron erzeugt!\n";
}




void neuron::resize(int size)
{
    this->size = size;
    
    try {
        in = new int[size];
        w = new int[size];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim ReAllozieren: neuron!\n";
        return;
    }
    
    for(int i=0; i<size; i++)
    { 
        in[i] = 0; 
        w[i] = 0; 
    }
}




void neuron::setIn(int *k)
{
    //Eingnge setzen
    for(int i=0; i<size; i++)
        in[i] = k[i];
    
    
    //Ausgang berechnen
    int sum=0;
    
    for(int i=0; i<size; i++)
        sum += w[i] * in[i];
    
    //signum(sum)
    if(sum < 0)
        out = -1;
    else
        out = 1;
}



//Neuronen Gewichtung
void neuron::setW(int *k, int akt)
{
    for(int i=0; i<size; i++)
        if(i != akt)
            w[i] += (k[akt] * k[i]);
}




