
#include "neuronet.h"


//Konstruktor
neuronet::neuronet(int neuroanz, int musteranz)
{
    this->musteranz = musteranz;
    this->neuroanz = neuroanz;
    
    //Neuronen und Mustererzeugen
    try {
        m = new muster[musteranz];
        n = new neuron[neuroanz];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: neuronet!\n";
        return;
    }
    
    //Neuronen auf richtige Gre setzen
    for(int i=0; i<neuroanz; i++)
        n[i].resize(neuroanz);
    
    //Muster auf richtige Gre setzen
    for(int i=0; i<musteranz; i++)
        m[i].resize(neuroanz);
    
}


//Destruktor
neuronet::~neuronet()
{
    delete [] n;
    delete [] m;
    //cout << "Destruktor erfolgreich: Neuronet geloescht\n";
}


//Copy-Konstruktor
neuronet::neuronet(const neuronet &net)
{
    musteranz = net.musteranz;
    neuroanz = net.neuroanz;
    
    try {
        m = new muster[musteranz];
        n = new neuron[neuroanz];
    } catch (bad_alloc xa) {
        cerr << "Fehler beim Allozieren: copy-neuronet!\n";
        return;
    }
    
    for(int i=0; i<musteranz; i++)
        m[i] = net.m[i];
   
    for(int i=0; i<neuroanz; i++)
        n[i] = net.n[i];
    
    //cout << "Kopie von Neuronet erzeugt!\n";
}




void neuronet::identify(muster rausch)
{
    int eingang[neuroanz], temp, i, compared=0;
    
    while(compared < 100)
    {
        if(compared == 0)
            cout << "\n\nEingabe:\n";
        else
            cout << "Iteration " << compared << ":\n";
        
        rausch.print();
        
        
        for(i=0; i<musteranz; i++)
        {
            if( m[i].compare_to(rausch) )
            {
                cout << "gefunden!\n";
                return;
            }
        }
        
        
        for(i=0; i<neuroanz; i++)
            eingang[i] = rausch.x[i];
        
        
        for(i=0; i<neuroanz; i++)
        {
            n[i].setIn(eingang);
            
            rausch.x[i] = n[i].out;
        }
        compared++;
    }
    
    cout << "Muster wurde nach " << compared-1 << " Versuchen nicht identifiziert...\n";
}





void neuronet::learn(void)
{
    FILE *fp;
    char s[20];
    
    cout << "Lernphase\n";
    
    if( (fp = fopen("muster", "r")) == NULL)
    {
        cerr << "Fehler beim Oeffnen der Orginaldatei\n";
        return;
    }
    
    //Muster einlesen
    for(int i=0; i<musteranz; i++)
    {
        m[i].set(fp);
        m[i].print();
    }
    fclose(fp);
    
    //Gewichtungen der Neuronen setzen
    for(int k=0; k<musteranz; k++)
        for(int i=0; i<neuroanz; i++)
            n[i].setW( m[k].x, i);
}

